/////////////////////////////////////////////////////////////////////////////////////////////+
//===========================================================================================+
//+------------------------------------------------------------------------------------------+
//|                                                                              vgTALIb.mqh |
//|                                               Copyright  2009, VladVG, VladislavVG (VG) |
//|                                                                           4vg AT mail.ru |
//+------------------------------------------------------------------------------------------+
//===========================================================================================+
/////////////////////////////////////////////////////////////////////////////////////////////+
#property copyright "Copyright  2009, VladVG, VladislavVG (VG)"
#property link      "4vg AT mail.ru"

//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+

#import "vgTALib.dll"
//===========================================================================================+
//+------------------------------------------------------------------------------------------+
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Common Service Functions Section <<<<<<<<<<<<<<<<<<<<<<<<<<+
//
int    vgfGetDigitsAf(double L);// Count of digits after Coma for 11.1237 it can be 4, for 114.23 it can be 2
int    vgfGetDigitsBf(double L);// Count of digits befor Coma for 11.1237 it can be 2, for 114.23 it can be 3
double vgfNormalizeDouble(double val, int digits);
//===========================================================================================+
//+------------------------------------------------------------------------------------------+
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Technical Indicators Section <<<<<<<<<<<<<<<<<<<<<<<<<<<<+
// ********************************* Moving Averages (MA) **********************************
//
 
/* MA_METHOD :
//   
#define MODE_SMA 0 
//   
#define MODE_EMA 1 
//   
#define MODE_SMMA 2 
//-   
#define MODE_LWMA 3 
*/
#define MODE_T3MA 4 
//#define MODE_NLMA 5 

int    t3ma(double& t3_buff[], double price[],    int T3_Period,  double b=0.7,    int BarsCnt=300, int from=0 );
int     sma(double& ma_buff[], double price[],    int MA_Period,  int BarsCnt=300, int from=0);
int     ema(double& ma_buff[], double price[],    int MA_Period,  int BarsCnt=300, int from=0);
int    smma(double& ma_buff[], double price[],    int MA_Period,  int BarsCnt=300, int from=0);
int    lwma(double& ma_buff[], double price[],    int MA_Period,  int BarsCnt=300, int from=0);
int      ma(int MA_METHOD,     double& ma_buff[], double price[], int MA_Period,   int BarsCnt=300, int from=0);
int    fEnv(double& env_up,    double& env_dn,    double wt[],    double EnvDvn,   int BarsCnt=300, int from=0);

//===========================================================================================+
//+------------------------------------------------------------------------------------------+
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Neural Network Section <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<+
// *************************** Fast Artifical Neural Network Lib (FANN) *********************
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!+
//  
//    f2M_  Mariusz Woloszyn Fann2MQL.wordpress.com
// ,        :
// 1. int fann4MT_create_standard(int layersCnt, int neuronsInlayer[]);
// 2. int fann4MT_get_output_vector(int ann, double& output_vector[]);
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!+
//+------------------------------------------------------------------------------------------+
//int fann4MT_create_standard(int layersCnt, int neuronsInlayer[]);
// Input : 
//    1. int layersCnt         - Count of FANN LaYers /   
//    2. int neuronsInlayer[]  - Array of Layers Neuron Count /       
// for f2M lib equ /    f2M,    Mariusz Woloszyn    : 
//     layers = 4, neuronsInlayer[] = {30,30,16,1};
//
// Return Value : if > 0 - Number of fann 
//                if < 0 - ERROR ! 
//+------------------------------------------------------------------------------------------+
//+------------------------------------------------------------------------------------------+
int fann4MT_create_standard(int layersCnt, int neuronsInlayer[]);
//===========================================================================================+
int fann4MT_create_from_file(string path);
int fann4MT_run(int ann, double& input_vector[]);
int fann4MT_destroy(int ann);
int fann4MT_destroy_all_anns();

int  fann4MT_get_num_input(int ann);
int  fann4MT_get_num_output(int ann);
double fann4MT_get_output(int ann, int output);
//===========================================================================================+
//+------------------------------------------------------------------------------------------+
// fann4MT_get_output_vector(int ann, double& output_vector[]);
// Input : 
//    1. int ann                  - No of fann
//    2. double& output_vector[]  - Pointer on array  for copy of fann output !vector CAN BE Allocated!
// Return Value : if > 0 - Size of fann # ann  OUTPUT Vector
//                if < 0 - ERROR ! 
//+------------------------------------------------------------------------------------------+
int fann4MT_get_output_vector(int ann, double& output_vector[]);
//+------------------------------------------------------------------------------------------+
//===========================================================================================+

int fann4MT_train(int ann, double& input_vector[], double& output_vector[]);
int fann4MT_train_fast(int ann, double& input_vector[], double& output_vector[]);
int fann4MT_randomize_weights(int ann, double min_weight, double max_weight);
double fann4MT_get_MSE(int ann);
int fann4MT_save(int ann, string path);
int fann4MT_reset_MSE(int ann);
int fann4MT_test(int ann, double& input_vector[], double& output_vector[]);
int fann4MT_set_act_function_layer(int ann, int activation_function, int layer);
int fann4MT_set_act_function_hidden(int ann, int activation_function);
int fann4MT_set_act_function_output(int ann, int activation_function);

/* legacy functions */
int fann4MT_fann_create_standard(int num_layers, int l1num, int l2num, int l3num, int l4num);
int fann4MT_Init(string path);
int fann4MT_Run(int ann, double& input_vector[]);
int fann4MT_Destroy(int ann);

//+------------------------------------------------------------------------------------------+
// *************************** Support Vector Machines Section (SVM)  ***********************+
// NOT READY FOR ATTACH YET !

#import

#define FANN_DOUBLE_ERROR	-1000000000

#define FANN_LINEAR                     0
#define FANN_THRESHOLD	                1
#define FANN_THRESHOLD_SYMMETRIC        2
#define FANN_SIGMOID                    3
#define FANN_SIGMOID_STEPWISE           4
#define FANN_SIGMOID_SYMMETRIC          5
#define FANN_SIGMOID_SYMMETRIC_STEPWISE 6
#define FANN_GAUSSIAN                   7
#define FANN_GAUSSIAN_SYMMETRIC         8
#define FANN_ELLIOT                     9
#define FANN_ELLIOT_SYMMETRIC           10
#define FANN_LINEAR_PIECE               11
#define FANN_LINEAR_PIECE_SYMMETRIC     12
#define FANN_SIN_SYMMETRIC              13
#define FANN_COS_SYMMETRIC              14
#define FANN_SIN                        15
#define FANN_COS                        16
#import

//+------------------------------------------------------------------+
//| EX4 imports                                                      |
//+------------------------------------------------------------------+
// #import "stdlib.ex4"
//   string ErrorDescription(int error_code);
// #import
//+------------------------------------------------------------------+